﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Reflection;
/// <summary>
/// Find 的摘要说明
/// </summary>
public  class BasePage  :System.Web.UI.Page
{
    public BasePage()
	{
		//
		// TODO: 在此处添加构造函数逻辑
		//
	}
    /// <summary>
    ///将 Model对象绑定页面控件
    /// </summary>
    /// <param name="model"></param>
    public void SetModelValueToControl(object model)
    {

         SetModelValueToControl(model, this);
        
    }
    /// <summary>
    /// 将 Model对象绑定页面控件
    /// </summary>
    /// <param name="model">对象</param>
    /// <param name="parentControl">页面的容器..form1 ,page 等</param>
    protected  void  SetModelValueToControl(object model, Control parentControl)
    {
        if (model == null) return;
        Type type = model.GetType();
        PropertyInfo[] info = type.GetProperties();
        Control c = null; ;
        object value=null;
        foreach (PropertyInfo p in info)
        {  
            c = checkControl(p.Name, parentControl);
            if (c != null)
            {
                type = c.GetType();
                if (type.Equals(typeof(TextBox)))
                {
                    value = p.GetValue(model, null);
                }
                if (type.Equals(typeof(DropDownList)))
                {
                    value = p.GetValue(model, null);
                }

                BindControlData(type, c, value);
            }

          
        }
    }
     /// <summary>
     /// 检查控件
     /// </summary>
     /// <param name="name">字段名,如 txtUsername ,则 传入 Username</param>
     /// <param name="parentcontrol">目标容器</param>
     /// <returns></returns>
    private Control checkControl(string name, Control parentcontrol)
    {
        Control c = null; ;
        if (parentcontrol.FindControl("txt" + name) != null)
        {
            c = parentcontrol.FindControl("txt" + name);
        }
        if (parentcontrol.FindControl("dlist" + name) != null)
        {
            c = parentcontrol.FindControl("dlist" + name);
        }
        return c;
    }
     /// <summary>
     /// 向页面绑定数据
     /// </summary>
     /// <param name="type"></param>
     /// <param name="c"></param>
     /// <param name="value"></param>
    protected void BindControlData(Type type, Control c, object value)
    {

        if (type.Equals(typeof(TextBox)))
        {
            if (value == null)
            {
                value = "";
            }
            ((TextBox)c).Text = value.ToString().Trim();
        }
        if (type.Equals(typeof(DropDownList)))
        {
            DropDownList ddlist = (DropDownList)c;
            if (value == null)
            {
                value = "";
                ddlist.SelectedIndex = 0;
            }
            else
            {
                ddlist.ClearSelection();
                ddlist.Items.Add(value.ToString());
            }
        }
    }
}
